SystemOrganization addCategory: #Proxies!
SystemOrganization addCategory: #'Proxies-Serializers'!
SystemOrganization addCategory: #'Proxies-Core'!
SystemOrganization addCategory: #'Proxies-Swapping'!
SystemOrganization addCategory: #'Proxies-Errors'!

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/13/2010 22:21'!
initialize 
	self addClassVarName: 'CurrentNumber'.
	self addClassVarName: 'IsRunnintTests'.
	CurrentNumber := 0.! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:44'!
installOn: aClass selector: aSel
	^ (self on: aClass selector: aSel)! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/13/2011 20:26'!
isRunningTest
	IsRunnintTests isNil ifTrue: [IsRunnintTests := true].
	^ IsRunnintTests ! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'mariano 11/26/2010 17:38'!
mareaAllInstalledProxies
	^ (1 to: self mareaCurrentNumber) select: [:each | each mareaIsProxyInstalled ] 
! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/26/2010 15:07'!
mareaAllInstalledProxiesCount
	^ self mareaAllInstalledProxies size! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'mariano 11/26/2010 17:37'!
mareaCurrentNumber
	CurrentNumber isNil ifTrue: [ CurrentNumber := 0 ].
	^ CurrentNumber
! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'mariano 11/26/2010 17:37'!
mareaNextNumber
	CurrentNumber := self mareaCurrentNumber + 1.
	^ CurrentNumber
! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/30/2010 17:30'!
mareaResetNumber.
	CurrentNumber := nil! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'mariano 11/27/2010 16:14'!
mareaUninstallIfNeededAllInstances
	(1 to: self mareaCurrentNumber) do: [:each | each mareaUninstallIfNeeded ] 
! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/1/2010 17:39'!
mareaUninstallIfNeededAllInstancesWithTracing: aLogger
	| counter |
	counter := 0.
	self mareaAllInstalledProxies do: [:instance| 
		(counter \\ 5000) isZero ifTrue: [
			aLogger log: ''.
			aLogger log: SmalltalkImage current vmStatisticsReportString.
			aLogger log: ''.
		]. 
	counter := counter + 1.
	instance mareaUninstallIfNeeded
	].! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 18:28'!
on: aMethodReference
	^self mareaNextNumber mareaInstallFor: aMethodReference 
	! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 17:44'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!SmallInteger class methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 17:37'!
runningTest: aBoolean
	IsRunnintTests := aBoolean  ! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/13/2010 22:38'!
class
	((self mareaClass isRunningTest) or: [self mareaIsProxyInstalled not])
		ifTrue: [^ self mareaClass ]
		ifFalse: [ ^ self mareaUninstall class ].
	! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
doesNotUnderstand: aMessage
	self mareaIsProxyInstalled 
		ifTrue: [ ^ CompiledMethodProxySwapperHandler mareaHandleDoesNotUnderstand: aMessage forProxy: self]
		ifFalse: [ ^ super doesNotUnderstand: aMessage ].
	! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/17/2010 18:56'!
flushCache
	"Tell the interpreter to remove all references to this method from its method lookup cache, if it has one.  This primitive must be called whenever a method is defined or removed.
	NOTE:  Only one of two selective flush methods needs to be used.
	Squeak 2.2 and earlier uses 119 (See Symbol flushCache).
	Squeak 2.3 and later uses 116 (See CompiledMethod flushCache)."

	<primitive: 116>
! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/30/2011 15:19'!
mareaDefineFileNameFor: aCompiledMethod
	^ self asString! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 11:26'!
mareaFileName
	^ self asString, '.swap'! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
mareaInstallFor: aMethodReference
	CompiledMethodProxySwapperHandler mareaInstallFor: aMethodReference andProxy: self
	! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/25/2010 16:51'!
mareaIsProxy
	^ true! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/24/2010 11:36'!
mareaIsProxyInstalled 
	^ FileDirectory default isAFileNamed: self mareaFileName! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/24/2010 12:15'!
mareaMarkAsUninstalled
	"We don't need to do anything for SmallInteger since to detect if it is uninstalled we check the existance off the file, which is removed during the uninstall'"! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/23/2010 12:15'!
mareaStoreFileNameIfNecessary: aFileName! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
mareaUninstall
	^ CompiledMethodProxySwapperHandler mareaUninstallForProxy: self
! !

!SmallInteger methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
mareaUninstallIfNeeded
	^ CompiledMethodProxySwapperHandler mareaUninstallIfNeeded: self
! !

!Behavior methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/14/2011 22:54'!
hasAllMethodsAsProxies
	^ self allMethods allSatisfy: [:aMethod | aMethod mareaIsProxy  ].
	! !

!Behavior methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/13/2011 22:50'!
methodDict
	methodDict == nil ifTrue: ["self manageMDFault" ^ self emptyMethodDictionary  ].
	^ methodDict! !

!CompiledMethod methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/17/2010 21:58'!
mareaPrintString 
	^ self methodClass asString, '>>', self selector.! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/13/2010 20:12'!
associationsDo: aBlock 
	| key |
	tally = 0 ifTrue: [^ self].
	1 to: self basicSize do:
		[:i | (key := self basicAt: i) == nil ifFalse:
			[ ((array at: i) mareaIsProxy) ifTrue: [(array at: i) mareaUninstall].
			aBlock value: (Association key: key
									value: (array at: i))]]! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/13/2010 20:13'!
at: key ifAbsent: aBlock

    | index value |
    index := self findElementOrNil: key.
    (self basicAt: index) == nil ifTrue: [ ^ aBlock value ].
    value := array at: index.
    (value mareaIsProxy) ifTrue: [value mareaUninstall].
    ^ array at: index! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 19:01'!
mareaAt: key 
	"Answer the value associated with the key."

	^ self mareaAt: key ifAbsent: [self errorKeyNotFound]! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/20/2010 19:00'!
mareaAt: key ifAbsent: aBlock

	| index |
	index := self findElementOrNil: key.
	(self basicAt: index) == nil ifTrue: [ ^ aBlock value ].
	^ array at: index! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/2/2010 11:31'!
mareaUninstallIfProxy: value
	(value mareaIsProxy) ifTrue: [value mareaUninstall].! !

!MethodDictionary methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 12/13/2010 20:12'!
valuesDo: aBlock 
	| value |
	tally = 0 ifTrue: [^ self].
	1 to: self basicSize do:
		[:i | (value := array at: i) == nil
			ifFalse: [
				(value mareaIsProxy) ifTrue: [value mareaUninstall].
				aBlock value: (array at: i)]]
		! !

ProtoObject subclass: #ObjectProxyHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

ObjectProxyHandler class
	instanceVariableNames: 'MareaSerializer'!

ObjectProxyHandler class
	instanceVariableNames: 'MareaSerializer'!

!ObjectProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/31/2011 15:21'!
mareaHandleInterception: aMessage for: aProxy
	^ self subclassResponsibility ! !

!ObjectProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 15:34'!
mareaInstallFor: anObject andProxy: aProxy
! !

!ObjectProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 15:34'!
mareaUninstallForProxy: aProxy
! !

!ObjectProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 15:34'!
mareaUninstallForProxy: aProxy ifNotInstalled: errorBLock
! !

!ObjectProxyHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/31/2011 09:48'!
mareaUninstallIfNeeded: aProxy
	^ [self mareaUninstallForProxy: aProxy] on: ProxyIsNotInstalled do: [].! !

!ObjectProxyHandler methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 3/13/2011 12:20'!
seeClassSide! !

ObjectProxyHandler subclass: #ObjectProxySwapperHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

ObjectProxySwapperHandler class
	instanceVariableNames: 'MareaSerializer'!

ObjectProxySwapperHandler class
	instanceVariableNames: 'MareaSerializer'!

ObjectProxySwapperHandler subclass: #ClassProxySwapperHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

ClassProxySwapperHandler class
	instanceVariableNames: 'MareaSerializer'!

ClassProxySwapperHandler class
	instanceVariableNames: 'MareaSerializer'!

!ClassProxySwapperHandler classSide methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 3/31/2011 18:25'!
mareaHandleInterception: aMessage for: aProxy
	| oldClass answer |
	"self mareaCheckLoop."
	self mareaLog: aProxy mareaClass name, ' cannotInterpret: ', aMessage selector.
	oldClass := self mareaUninstallForProxy: aProxy.
	self mareaLog: 'The message will be sent to the original object'.
	answer := aProxy perform: aMessage selector withArguments: aMessage arguments.
	self mareaLog: 'The message was sent to the original object'.
	^ answer.! !

!ClassProxySwapperHandler classSide methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 3/31/2011 18:23'!
mareaHandleInterception: aMessage for: aProxy receiver: anObject
	| answer |
	self mareaLog: 'cannotInterpret: ', aMessage selector.
	self mareaUninstallForProxy: aProxy.
	self mareaLog: 'The message will be sent to the original object'.
	answer := aMessage sendTo: anObject.
	self mareaLog: 'The message was sent to the original object'.
	^ answer 
! !

!ClassProxySwapperHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/31/2011 17:45'!
mareaInstallFor: aClass andProxy: aProxy
	| className  |
	"There is a problem with compact classes since their instances, do not have a class pointer, and hence, the #become: doesn't update those pointers to point to my proxy. So....nothing to do."	
	aClass indexIfCompact isZero ifFalse: [ CannotProxifyCompactClasses new signal: 'It is not possible to create class proxies for compact classes' ].

	["The other alternative is being able to create proxies for profies, but the proxy 
	handlers expect a Class and not a proxy."
	aClass mareaIsProxy.
	] whileTrue: [aClass mareaUninstall].

	className := aClass name.
	self mareaLog: 'The class ', aClass name, ' is being wrapped'. 
	self mareaWriteObjectOnDisk: aClass andProxy: aProxy.
	aClass become: aProxy.
	self flag: #fixit.
	"THIS MUST BE REMOVED WHEN THE SERIALIZATION OF A CLASS IS WORKING"
	"and the become should be:  aClass becomeForward: aProxy   so that nobody else points to the class and it can be garbage collected"
	"remember that I use cannotInterpret:   so I cannot send ANY message to the proxy because otherwise it will be uninstalled!!"
	
	aClass result: aProxy.
	self mareaLog: 'The class ', className , ' was wrapped'.
	! !

!ClassProxySwapperHandler classSide methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 3/31/2011 18:32'!
mareaLoadObjectFor: aProxy
	self flag: #fixit.
	"THIS MUST BE REMOVED WHEN THE SERIALIZATION OF A CLASS IS WORKING"
	^ aProxy result
"	^ self mareaSerializer mareaUnserializeClassFrom: aProxy mareaFileName result: aProxy result.
"	! !

!ClassProxySwapperHandler classSide methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 3/31/2011 17:15'!
mareaWriteObjectOnDisk: anObject andProxy: aProxy
	| refStream fileName result | 
	fileName := (aProxy mareaDefineFileNameFor: anObject).
	[ fileName := fileName, '.swap' ] 
		doWhileTrue: [(FileDirectory default isAFileNamed: fileName)].
	"all this thing of the result should be removed when the class serialization is working"
	result := self mareaSerializer mareaSerializeAndWriteObject: anObject to: fileName.
	aProxy mareaStoreFileNameIfNecessary: fileName result: result. 
	self mareaLog: 'The object ', anObject mareaPrintString, ' was written on file named: ', fileName.

! !

!ClassProxySwapperHandler methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 3/31/2011 17:15'!
seeClassSide! !

ObjectProxySwapperHandler subclass: #CompiledMethodProxySwapperHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

!CompiledMethodProxySwapperHandler classSide methodsFor: 'constants' stamp: 'MarianoMartinezPeck 11/25/2010 10:11'!
loopTreshhold
	^ 10! !

!CompiledMethodProxySwapperHandler classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 3/13/2011 12:37'!
mareaCheckLoop
	| ctxt runWithInMethodProxy runWithInMethodProxyReceiver proxySender found startingPoint loopCounter |

	ctxt := thisContext.
	loopCounter := 0.
	
	ctxt sender ifNil: [^ self].
	ctxt sender sender ifNil: [^ self].
	ctxt sender sender sender ifNil: [^ self].
	
	runWithInMethodProxy := ctxt sender sender method.
	runWithInMethodProxyReceiver :=  ctxt sender sender receiver. 
	proxySender := ctxt sender sender sender method.
	startingPoint := ctxt sender sender sender.
	
"	ToolSet inspect: ctxt sender sender sender label: 'where to start'. 
	ToolSet inspect: runWithInMethodProxy label: 'runWithInMethodProxy'.
	ToolSet inspect: runWithInMethodProxyReceiver label: 'runWithInMethodProxyReceiver'.
	ToolSet inspect: proxySender label: 'proxySender'."
	
	[startingPoint isNil ifFalse: [
		loopCounter := loopCounter + 1.
		found := startingPoint findContextSuchThat: [:aContext | 
			(aContext sender isNil not) and:  [
				(aContext sender method == proxySender) 
				and: [
					(runWithInMethodProxyReceiver == aContext receiver)
						and: [aContext method == runWithInMethodProxy ]]
			]
		].
		 found isNil ifFalse: [ startingPoint := found sender].
		]
	] doWhileTrue: [ (found isNil not and: [loopCounter < self loopTreshhold ]) and: [startingPoint isNil not] ].
	
	

	
	(loopCounter = self loopTreshhold) ifTrue: [ 
		self mareaLog: 'LOOP ---- ', ctxt sender sender tempsAndValues asString. 
		(PossibleLoopDetection with: ctxt sender sender tempsAndValues)
		signal: 'It is possible that a proxy that was needed to swap is, was swapped out.' ].
! !

!CompiledMethodProxySwapperHandler classSide methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 3/31/2011 15:23'!
mareaHandleMethodExecutionFor: aSelector with: arguments in: aReceiver proxy: aProxy
	| aResult oldMethod |
	self mareaCheckLoop.
	self mareaLog: 'The method ', aSelector, ' is being executed with a receiver instance of ', aReceiver mareaClass name.
	oldMethod := self mareaUninstallForProxy: aProxy.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	self mareaLog: 'The method ', aSelector, ' was executed with a receiver instance of ', aReceiver mareaClass name.
	^aResult
	! !

!CompiledMethodProxySwapperHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/14/2011 19:40'!
mareaInstallFor: aMethodReference andProxy: anObject
	| oldMethod oldClass selector |
	oldClass := aMethodReference actualClass. 
	selector := aMethodReference  selector. 
	[oldMethod := oldClass lookupSelector: selector.
	oldMethod isNil ifTrue: [
		SelectorNotFoundError signal: ('The selector: ', aMethodReference  selector asString, 
		' was not found in the class: ', aMethodReference actualClass name asString)].
	"The other alternative is being able to create proxies for profies, but the proxy 
	handlers expect a CompiledMethod and not a proxy."
		oldMethod mareaIsProxy.
	] whileTrue: [oldMethod mareaUninstall].
	"oldMethod methodClass superclass isNil ifTrue: [self mareaLog: 'A CompiledMethod cannot be swapped out if the superclass of the class where it is installed is not a subclass of at least ProtoObject. Method: ', oldMethod mareaPrintString].    "
	self mareaLog: 'The method ', aMethodReference mareaPrintString, ' is being wrapped'.
	self mareaWriteObjectOnDisk: oldMethod andProxy: anObject.
	oldClass methodDict at: selector put: anObject.
	self mareaLog: 'The method ', aMethodReference mareaPrintString, ' was wrapped'.
	! !

!CompiledMethodProxySwapperHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/31/2011 15:48'!
mareaUninstallForProxy: aProxy ifNotInstalled: errorBLock
	| oldMethod |
	self mareaLog: 'Starting to uninstall.'.
	aProxy mareaIsProxyInstalled ifFalse: [ 
		self mareaLog: 'The proxy is not installed'.
		errorBLock value ].
	self mareaLog: 'Trying to load.'.
	oldMethod := self mareaLoadObjectFor: aProxy.
	self mareaLog: 'The object ', oldMethod name, ' was loaded form file.'.
	
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	
	self mareaLog: 'The Proxy for ', oldMethod mareaPrintString, ' was uninstalled.'.
	self mareaRemoveFile: aProxy mareaFileName.
	aProxy mareaMarkAsUninstalled.
	^ oldMethod.  
! !

!CompiledMethodProxySwapperHandler methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 11/25/2010 17:02'!
seeClassSide! !

!ObjectProxySwapperHandler classSide methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 3/31/2011 15:21'!
mareaHandleInterception: aMessage for: aProxy
	| answer oldObject |
	self mareaLog: 'cannotInterpret: ', aMessage selector.
	oldObject := self mareaUninstallForProxy: aProxy.
	self mareaLog: 'The message will be sent to the original object'.
	answer := aMessage sendTo: oldObject.
	self mareaLog: 'The message: ', aMessage selector asString, ' was sent to the original object'.
	^ answer 
! !

!ObjectProxySwapperHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 15:25'!
mareaInstallFor: anObject andProxy: aProxy
	| objectName  |
	["The other alternative is being able to create proxies for profies, but the proxy 
	handlers expect a Class and not a proxy."
	anObject mareaIsProxy.
	] whileTrue: [anObject mareaUninstall].

	objectName := anObject name.
	self mareaLog: 'The object ', objectName , ' is being wrapped'. 
	self mareaWriteObjectOnDisk: anObject andProxy: aProxy.
	anObject become: aProxy.

	self mareaLog: 'The object ', objectName , ' was wrapped'.
! !

!ObjectProxySwapperHandler classSide methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 3/30/2011 15:25'!
mareaLoadObjectFor: aProxy
	^ self mareaSerializer mareaUnserializeObjectFrom: aProxy mareaFileName
	! !

!ObjectProxySwapperHandler classSide methodsFor: 'private' stamp: 'MarianoMartinezPeck 3/30/2011 15:25'!
mareaRemoveFile: aFileName
	FileDirectory default deleteFileNamed: aFileName
	
! !

!ObjectProxySwapperHandler classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 15:25'!
mareaSerializer
	MareaSerializer isNil ifTrue: [MareaSerializer := FuelMareaSerializer new].
	^ MareaSerializer! !

!ObjectProxySwapperHandler classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 15:25'!
mareaSerializer: aMareaSerializer
	MareaSerializer := aMareaSerializer new! !

!ObjectProxySwapperHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 15:25'!
mareaUninstallForProxy: aProxy
	^ self mareaUninstallForProxy: aProxy ifNotInstalled: [ ProxyIsNotInstalled signal: 'The proxy is not installed. '].! !

!ObjectProxySwapperHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/31/2011 15:48'!
mareaUninstallForProxy: aProxy ifNotInstalled: errorBLock
	| oldObject |
	
	self mareaLog: 'Starting to uninstall.'.
	aProxy mareaIsProxyInstalled ifFalse: [ 
		self mareaLog: 'The proxy is not installed'.
		errorBLock value ].
	self mareaLog: 'Trying to load.'.
	oldObject := self mareaLoadObjectFor: aProxy.
	self mareaLog: 'The object ', oldObject name, ' was loaded form file.'.
	
	oldObject become: aProxy.
	
	"now oldClass points to the proxy and aProxy points to the old class"
	self mareaLog: 'The Proxy for ', aProxy name, ' was uninstalled.'.
	self mareaRemoveFile: oldObject mareaFileName.
	oldObject mareaMarkAsUninstalled.
	^ aProxy.  
! !

!ObjectProxySwapperHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 15:25'!
mareaUninstallIfNeeded: aProxy
	^ [self mareaUninstallForProxy: aProxy] on: ProxyIsNotInstalled do: [].! !

!ObjectProxySwapperHandler classSide methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 3/30/2011 15:25'!
mareaWriteObjectOnDisk: anObject andProxy: aProxy
	| refStream fileName | 
	fileName := (aProxy mareaDefineFileNameFor: anObject).
	[ fileName := fileName, '.swap' ] 
		doWhileTrue: [(FileDirectory default isAFileNamed: fileName)].
	self mareaSerializer mareaSerializeAndWriteObject: anObject to: fileName.
	aProxy mareaStoreFileNameIfNecessary: fileName. 
	self mareaLog: 'The object ', anObject mareaPrintString, ' was written on file named: ', fileName.
! !

!ObjectProxySwapperHandler methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 3/30/2011 15:25'!
seeClassSide! !

ObjectProxyHandler subclass: #ObjectProxyTracerHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

ObjectProxyTracerHandler class
	instanceVariableNames: 'MareaSerializer'!

ObjectProxyTracerHandler class
	instanceVariableNames: 'MareaSerializer'!

!ObjectProxyTracerHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/31/2011 15:21'!
mareaHandleInterception: aMessage for: aProxy
	| answer  |
	self mareaLog: 'cannotInterpret: ', aMessage selector.
	self mareaLog: 'The message will be sent to the original object'.
	answer := aMessage sendTo: aProxy target.
	self mareaLog: 'The message: ', aMessage selector asString, ' was sent to the original object'.
	^ answer 
! !

!ObjectProxyTracerHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 16:02'!
mareaInstallFor: anObject andProxy: aProxy
	| objectName  |
	["The other alternative is being able to create proxies for profies, but the proxy 
	handlers expect a Class and not a proxy."
	anObject mareaIsProxy.
	] whileTrue: [anObject mareaUninstall].

	objectName := anObject name.
	self mareaLog: 'The object ', objectName , ' is being wrapped'. 
	aProxy target: anObject.
	self mareaLog: 'The object ', objectName , ' was wrapped'.
! !

!ObjectProxyTracerHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 16:03'!
mareaUninstallForProxy: aProxy
	^ self mareaUninstallForProxy: aProxy ifNotInstalled: [ ProxyIsNotInstalled signal: 'The proxy is not installed. '].! !

!ObjectProxyTracerHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 16:42'!
mareaUninstallForProxy: aProxy ifNotInstalled: errorBLock
	
	self mareaLog: 'Starting to uninstall.'.
	aProxy mareaIsProxyInstalled ifFalse: [ errorBLock value ].
	aProxy mareaMarkAsUninstalled.
	self mareaLog: 'The Proxy was uninstalled.'.
	^ aProxy.  
! !

!ObjectProxyTracerHandler classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 16:03'!
mareaUninstallIfNeeded: aProxy
	^ [self mareaUninstallForProxy: aProxy] on: ProxyIsNotInstalled do: [].! !

!ObjectProxyTracerHandler methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 3/30/2011 15:57'!
seeClassSide! !

!ProtoObject methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 10/20/2010 11:33'!
class
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!ProtoObject methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/17/2010 19:53'!
mareaClass
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!MethodReference methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 11/28/2010 20:21'!
mareaPrintString
	^ self actualClass name, ' >> #', methodSymbol! !

Object subclass: #CompiledMethodSwapper
	instanceVariableNames: ''
	classVariableNames: 'Logger ProxyClass'
	poolDictionaries: ''
	category: 'Proxies-Swapping'!

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/21/2010 15:14'!
classesNotToSwap

	| tooDangerousClasses coreClasses protoObjectSubclasses classesSpecialArray veryUsedClasses allClasses debuggingClasses nilSubclasses |

	"This are classes that are known as too dangerous."
	tooDangerousClasses := OrderedCollection new.
	(ClassBuilder new tooDangerousClasses) 
		do: [:each | Smalltalk globals at: each 
			ifPresent: [:present | tooDangerousClasses add: (Smalltalk at: each) ] 
			ifAbsent: []].
	
	"These classes because they are too core and used by the code to swapout itseld"
	coreClasses :=  {Array. Object. ProtoObject. Class. Message. MethodDictionary. CompiledMethod}. 

	"Subclasses of ProtoObject because they do not implement some methods that Object does and that are used by the swapping stuff."
	protoObjectSubclasses := ProtoObject subclasses.
	
	"These classes cannot be swapped because they are used by the VM"
	classesSpecialArray := Smalltalk specialObjectsArray select: [ :each | each isBehavior ].
	
	"These classes cannot be swapped because they install the segment (they are used) even before the segment can be written into a file"
	veryUsedClasses := { Cursor. CursorWithMask. EncodedCharSet.}.
	
	"Classes that are usually needed to debug and they help us to analyze problems"
	debuggingClasses := { DEVToolSet. }.
	
	"nil subclasses cannot be swapped out because since they don't subclass ProtoObject they may not even implement doesNotUnderstand:.
	For example, if we swap a CompiledMethod of PseudoContext, and then we try to load it back, the VM will crash with the error Recursive not understood error encountered. '"
	nilSubclasses := nil subclasses.
	
	allClasses := coreClasses, protoObjectSubclasses, classesSpecialArray, veryUsedClasses, tooDangerousClasses, debuggingClasses, nilSubclasses.
	
	^ allClasses asOrderedCollection ! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2010 17:53'!
compiledMethodsToSwap
	|  methodsToSwap classesNotToSwap packagesNotToSwap fixedMethodsNotToSwap |
	
	UnusedObjectDiscoverer current startDiscovery. 
	
	self discoverMinimalUsedCompiledMethods.
	self methodsUsedByMareaTesting.
	
	packagesNotToSwap := self packagesNotToSwap.
	
	classesNotToSwap := self classesNotToSwap.
	packagesNotToSwap do: [:aPackage | classesNotToSwap addAll: aPackage classes ].
	
	fixedMethodsNotToSwap := self fixedMethodsNotToSwap.
	fixedMethodsNotToSwap do: [:aMethod | 	UnusedObjectDiscoverer current primitiveSetUsedBit: aMethod boolean: true].
	
	classesNotToSwap do: [:aClass | aClass markAllInstanceAndClassMethodsAsUsed].
	
	UnusedObjectDiscoverer current stopDiscovery.
	
	methodsToSwap := CompiledMethod unusedInstances.
	Transcript show: 'Methods to swap: ',  methodsToSwap size asString; cr.
	Transcript show: 'Methods NOT to swap: ',  CompiledMethod usedInstances size asString; cr.
	
	^ methodsToSwap


! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/27/2010 17:05'!
discoverMinimalUsedCompiledMethods
"These the minimal CompiledMethods needed to install and install a CompiledMethodProxy"
	| aProxy |
	
	SystemNavigation default browseClass: Object.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	(ClassWith1Var methodDict at: #foo) literals.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	ClassWith1Var new foo.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/31/2011 16:10'!
exampleSwapOutAllUnusedMethods 
	"self nose"
	| methodsToSwap timeToInstall timeToUninstall counter |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxySwapperHandler mareaSerializer: FuelMareaSerializer. 
	self proxyClass: NumberAsFilenameCompiledMethodProxySwapper.
	self proxyClass runningTest: false.
	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	"self printSpaceTally.
"	methodsToSwap := self compiledMethodsToSwap.
	
	CompiledMethodProxySwapperHandler mareaSerializer: FuelMareaSerializer. 
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	
	counter := 0.
	[timeToInstall := MessageTally time: [
	methodsToSwap do: [:method| 
		(counter \\ 5000) isZero ifTrue: [
			self log: ''.
			"self log: SmalltalkImage current vmStatisticsReportString."
			self log: ''.
		]. 
		counter := counter + 1.
		self installOn: method methodClass selector: method selector.].
	].

	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.

"	timeToUninstall := MessageTally time: [
		counter := 0.
		self proxyClass mareaAllInstalledProxies do: [:instance| 
			(counter \\ 5000) isZero ifTrue: [
				self log: ''.
				self log: SmalltalkImage current vmStatisticsReportString.
				self log: ''.
				self printSpaceTally.
			]. 
		counter := counter + 1.
		instance mareaUninstallIfNeeded
		].		
	]."
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	"self printSpaceTally."
	] ensure: [
		self log: 'Ensure....'.
		MareaLogger changeToFileLogger.
		"self proxyClass mareaUninstallIfNeededAllInstances."
"		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."
	]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/31/2011 18:51'!
exampleSwapOutAllUnusedMethodsAndClasses
	"self nose"
	| methodsToSwap timeToInstall timeToUninstall counter |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxySwapperHandler mareaSerializer: FuelMareaSerializer. 
	self proxyClass: NumberAsFilenameCompiledMethodProxySwapper.
	self proxyClass runningTest: false.
	Logger := nil.
	MareaLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Methods Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Class Proxies installed instances before start: ', ClassProxySwapper mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Classes instances before start: ', Smalltalk allClassesAndTraits size asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	"self printSpaceTally.
"	methodsToSwap := self compiledMethodsToSwap.
	
	CompiledMethodProxySwapperHandler mareaSerializer: FuelMareaSerializer. 
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	
	counter := 0.
	[timeToInstall := MessageTally time: [
	methodsToSwap do: [:method| 
		(counter \\ 5000) isZero ifTrue: [
			self log: ''.
			"self log: SmalltalkImage current vmStatisticsReportString."
			self log: ''.
		]. 
		counter := counter + 1.
		self installOn: method methodClass selector: method selector.].
	].

	Smalltalk allClassesDo: [:aClass | aClass hasAllMethodsAsProxies ifTrue: [ClassProxySwapper installOn: aClass ]. ].

	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Methods Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	self log: 'Class Proxies intalled: ',  ClassProxySwapper  mareaAllInstalledProxiesCount asString.
	self log: 'Class instances after installing: ', Smalltalk allClassesAndTraits size asString.
	
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.

"	timeToUninstall := MessageTally time: [
		counter := 0.
		self proxyClass mareaAllInstalledProxies do: [:instance| 
			(counter \\ 5000) isZero ifTrue: [
				self log: ''.
				self log: SmalltalkImage current vmStatisticsReportString.
				self log: ''.
				self printSpaceTally.
			]. 
		counter := counter + 1.
		instance mareaUninstallIfNeeded
		].		
	]."
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Method Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Class Proxies installed instances after uninstalling: ', ClassProxySwapper  mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	self log: 'Class instances after uninstalling: ', Smalltalk allClassesAndTraits size asString.
	"self printSpaceTally."
	] ensure: [
		self log: 'Ensure....'.
		MareaLogger changeToFileLogger.
		"self proxyClass mareaUninstallIfNeededAllInstances."
"		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."
	]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 3/31/2011 16:10'!
exampleSwapOutUnusedTests
	"self exampleSwapOutUnusedTests"
	| methodsToSwap timeToInstall timeToUninstall |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxySwapperHandler mareaSerializer: FuelMareaSerializer. 
	self proxyClass: NumberAsFilenameCompiledMethodProxySwapper.
	MareaLogger changeToFileLogger.
	Logger := nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	Symbol compactSymbolTable.
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	methodsToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'Test'] ) do: [:aPackage |
		aPackage classes do: [:aClass |
			methodsToSwap addAll: aClass unusedMethods
			].
		].
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	[
	timeToInstall := MessageTally time: [
	methodsToSwap do: [:method| self installOn: method methodClass selector: method selector.].
	].
	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	Symbol compactSymbolTable.
	self log: 'Memory used using proxies after compacting symbol table: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.
	timeToUninstall := MessageTally time: [self proxyClass mareaUninstallIfNeededAllInstances].
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	] ensure: [
		self proxyClass mareaUninstallIfNeededAllInstances.
		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/28/2010 23:30'!
fixedMethodsNotToSwap
	^ self selectorsNotToSwap
		inject: OrderedCollection new
		into: [:allMethods :aSelector | 
			allMethods addAll: 
				((SystemNavigation default allImplementorsOf: aSelector) 
					collect: [:aMethodReference | aMethodReference compiledMethod ] ); yourself 
		]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:27'!
installOn: aClass selector:  aSelector.
	^ self proxyClass installOn: aClass selector: aSelector.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackages
	^ self listOfCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^  #('MultilingualTests' 'Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'Tests' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'ToolsTest' 'Gofer-Core' 'Gofer-Tests' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'Tests-VM' 'System-Change Notification' 'System' 'Tests-ObjectsAsMethods' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'MorphicTests' 'System-Serial Port' 'NetworkTests' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Tests-PrimCallController' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'KernelTests' 'System-FileRegistry' 'Tests-Bugs' 'ToolBuilder-SUnit' 'Tests-Release' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'CompilerTests' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Tests-SystemChangeNotification' 'GraphicsTests' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'FreeTypeTests' 'Settings-Monticello' 'HelpSystem-Tests' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'CollectionsTests' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfNotDangerousCorePackages
	^ self listOfNotDangerousCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/22/2010 21:40'!
listOfNotDangerousCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^ #('Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'Gofer-Core' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'System-Change Notification' 'System' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'System-Serial Port' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'System-FileRegistry' 'ToolBuilder-SUnit' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'Settings-Monticello' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2010 13:27'!
log: aString
	self logger log: aString ! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2010 13:32'!
logger	
	Logger isNil ifTrue: [
		Logger := FixesFileNameLoggerStrategy named: 'Swapper.txt'.
		Logger startLogging].
	^ Logger! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2010 18:09'!
methodsUsedByMareaTesting
	| suite |
	suite := TestSuite named: 'zaraza'. 
	AbstractCompiledMethodProxyTest withAllSubclasses do: [:each |
		TestCase addTestsFor: each name toSuite: suite.].
	suite tests: (suite tests reject: [:each | each testSelector = #testCompiledMethodProxyAndGC]). 
	suite run. 
 ! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/29/2010 00:01'!
packagesNotToSwap.

	^ (# ('System-Object Storage' 'Fuel' 'Kernel' 'Graphics' 'Exceptions' 'Proxies' 'Settings' 'System' 'UsedObject' 'Traits' 'Balloon' 'Tools' 'Morphic') collect: [:aPackageName | PackageInfo named: aPackageName]),
	(PackageInfo allPackages select: [:each | each packageName includesSubString: 'Collections-' ])
	! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/2/2010 16:04'!
printSpaceTally
	self log: ''.
	self log: ''.
	SpaceTally new printSpaceAnalysis: 1 on: self logger logFile maxResults: 10. 
	self log: ''.
	self log: ''.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:24'!
proxyClass
	^ ProxyClass! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/21/2010 16:25'!
proxyClass: aProxyClass
	ProxyClass := aProxyClass.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/1/2010 10:19'!
selectorsNotToSwap
	^ #(#class), (Smalltalk specialObjectsArray select: [:each | each isSymbol])! !

Object subclass: #MareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Serializers'!

MareaSerializer subclass: #FuelMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Serializers'!

!FuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 3/13/2011 13:42'!
mareaSerializeAndWriteObject: anObject to: aFileName
	| serializer aFileStream | 
	aFileStream := (StandardFileStream fileNamed: aFileName) binary.
	serializer := FLSerializer on: aFileStream.
	serializer serialize: anObject.
	aFileStream close.
	self mareaLog: 'The object ', anObject name, ' was written on file'.
! !

!FuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 3/13/2011 18:08'!
mareaUnserializeObjectFrom: aFileName
	| materializer aFileStream |
	aFileStream := (StandardFileStream fileNamed: aFileName) binary.
	materializer := FLMaterializer on: aFileStream.
	materializer materialize.
	aFileStream close.
	^ materializer root
! !

MareaSerializer subclass: #ImageSegmentMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Serializers'!

!ImageSegmentMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 1/19/2011 14:44'!
mareaSerializeAndWriteClass: aClass to: aFileName
	| segment | 
	segment := ImageSegment new
		copyFromRoots: (Array with: aClass with: aClass class)
		sizeHint: 5000
		areUnique: true.
	segment segmentName: aFileName.
	FileStream forceNewFileNamed: aFileName do: 
		[ :stream | segment writeForExportOn: stream ].
	self mareaLog: 'The class ', aClass name, ' was written on file'.
	^ segment.


"mareaSerializeAndWriteClass: aClass to: aFileName
	| segment | 
	segment := ImageSegment new
		copyFromRoots: (Array with: aClass)
		sizeHint: 5000
		areUnique: true.
	segment extract.
	segment segmentName: aFileName.
	segment writeToFile.
	self mareaLog: 'The class ', aClass name, ' was written on file'.
	^ segment.
"! !

!ImageSegmentMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 1/19/2011 14:44'!
mareaUnserializeClassFrom: aFileName result: aResult
	| stream |
	stream := FileStream oldFileNamed: aFileName.
	^ stream fileInObjectAndCode arrayOfRoots first
	

"mareaUnserializeClassFrom: aFileName result: aResult
	^ aResult install arrayOfRoots first. 
	"! !

MareaSerializer subclass: #ImageSegmentSwapMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Serializers'!

!ImageSegmentSwapMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 1/19/2011 14:45'!
mareaSerializeAndWriteClass: aClass to: aFileName
	| segment | 
	segment := ImageSegment new
		copyFromRoots: (Array with: aClass)
		sizeHint: 5000
		areUnique: true.
	segment extract.
	segment segmentName: aFileName.
	segment writeToFile.
	self mareaLog: 'The class ', aClass name, ' was written on file'.
	^ segment.! !

!ImageSegmentSwapMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 1/19/2011 14:45'!
mareaUnserializeClassFrom: aFileName result: aResult
	^ aResult install arrayOfRoots first. 
! !

!MareaSerializer methodsFor: 'API' stamp: 'MarianoMartinezPeck 3/14/2011 19:08'!
mareaSerializeAndWriteObject: anObject to: aFileName
	self shouldBeImplemented ! !

!MareaSerializer methodsFor: 'API' stamp: 'MarianoMartinezPeck 3/14/2011 19:09'!
mareaUnserializeObjectFrom: aFileName
	self shouldBeImplemented ! !

MareaSerializer subclass: #ReferenceStreamMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Serializers'!

!ReferenceStreamMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 3/14/2011 19:03'!
mareaSerializeAndWriteObject: anObject to: aFileName
	| refStream | 
	refStream := ReferenceStream fileNamed: aFileName.
	refStream nextPut: anObject.
	refStream close.
	self mareaLog: 'The object ', anObject name, ' was written on file'.
! !

!ReferenceStreamMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 3/14/2011 19:02'!
mareaUnserializeObjectFrom: aFileName
	| refStream aClass |
	refStream := ReferenceStream fileNamed: aFileName.
	aClass := refStream next.
	refStream close.
	^ aClass! !

!Object methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 3/14/2011 19:42'!
mareaPrintString
	^ self printString! !

Object subclass: #ObjectProxyInterceptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

!ObjectProxyInterceptor methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 3/31/2011 18:23'!
cannotInterpret: aMessage
	| proxy |
	proxy := aMessage lookupClass.
	"If the lookUp class is a proxy, it means that it was a class proxy. Otherwise, lookupClass should be a class of a proxy, which is not a proxy"
	proxy mareaIsProxy
		ifTrue:   [
			^ proxy mareaHandler mareaHandleInterception: aMessage for: proxy receiver: self
		]
	 	ifFalse: [
			self mareaIsProxyInstalled 
				ifTrue: [^ self mareaHandler mareaHandleInterception: aMessage for: self]
				ifFalse: [
					aMessage lookupClass: thisContext method methodClass.
					"I could replace this by aMessage lookupClass: ObjectProxyInterceptor.
					but I prefer not to hardcode the class"
					^ self mareaPerform: aMessage selector withArguments: aMessage arguments  inSuperclass: aMessage lookupClass
				]
			]! !

ObjectProxyInterceptor subclass: #ObjectProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

ObjectProxyTrap subclass: #AbstractObjectProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

AbstractObjectProxy class
	instanceVariableNames: 'IsRunnintTests'!

AbstractObjectProxy class
	instanceVariableNames: 'IsRunnintTests'!

AbstractObjectProxy subclass: #AbstractClassProxy
	instanceVariableNames: 'superclass methodDict format'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

!AbstractClassProxy methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 3/31/2011 18:40'!
initialize
	superclass := ObjectProxyInterceptor.
	methodDict := nil.
	format := Object format! !

!AbstractClassProxy methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/31/2011 18:18'!
mareaHandler
	^ ClassProxySwapperHandler! !

AbstractClassProxy subclass: #AbstractClassProxySwapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

!AbstractClassProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 18:43'!
mareaDefineFileNameFor: anObject
	^ self subclassResponsibility! !

!AbstractClassProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 18:43'!
mareaFileName
	^ self subclassResponsibility ! !

!AbstractClassProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/31/2011 18:42'!
mareaHandler
	^ ClassProxySwapperHandler! !

!AbstractClassProxySwapper methodsFor: 'testing' stamp: 'MarianoMartinezPeck 3/31/2011 18:43'!
mareaIsProxyInstalled
	^ self subclassResponsibility ! !

!AbstractClassProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/31/2011 18:43'!
mareaMarkAsUninstalled
	! !

!AbstractClassProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/31/2011 18:43'!
mareaStoreFileNameIfNecessary: aFileName
	! !

!AbstractClassProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/31/2011 18:44'!
mareaStoreFileNameIfNecessary: aFileName result: aResult
	! !

AbstractClassProxySwapper subclass: #ClassProxySwapper
	instanceVariableNames: 'result fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

!ClassProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 18:39'!
mareaDefineFileNameFor: aClass
	^ aClass name! !

!ClassProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 18:39'!
mareaFileName
	^ fileName! !

!ClassProxySwapper methodsFor: 'testing' stamp: 'MarianoMartinezPeck 3/31/2011 18:39'!
mareaIsProxyInstalled
	^  fileName isNil not! !

!ClassProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/31/2011 18:39'!
mareaMarkAsUninstalled
	fileName := nil.! !

!ClassProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/31/2011 18:39'!
mareaStoreFileNameIfNecessary: aFileName
	fileName := aFileName! !

!ClassProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/31/2011 18:39'!
mareaStoreFileNameIfNecessary: aFileName result: aResult
	fileName := aFileName.
	result := aResult! !

!ClassProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 18:39'!
result 
	^ result! !

!ClassProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 18:39'!
result: aResult
	result := aResult ! !

AbstractObjectProxy subclass: #AbstractCompiledMethodProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

!AbstractCompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 12/1/2010 18:07'!
installOn: aClass selector: aSel
	^ (self on: aClass selector: aSel)! !

!AbstractCompiledMethodProxy classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/1/2010 18:06'!
mareaAllInstalledProxies
	^ self allInstances select: [:each | each mareaIsProxyInstalled ]
 
! !

!AbstractCompiledMethodProxy classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/1/2010 18:06'!
mareaAllInstalledProxiesCount
	^ self mareaAllInstalledProxies size
	
 
! !

!AbstractCompiledMethodProxy classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/31/2011 12:31'!
mareaUninstallIfNeededAllInstances
	self allInstancesDo: [:each | each mareaUninstallIfNeeded ]
 
! !

!AbstractCompiledMethodProxy classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/1/2010 18:06'!
mareaUninstallIfNeededAllInstancesWithTracing: aLogger
	| counter |
	counter := 0.
	self allInstancesDo: [:instance| 
		(counter \\ 5000) isZero ifTrue: [
			aLogger log: ''.
			aLogger log: SmalltalkImage current vmStatisticsReportString.
			aLogger log: ''.
		]. 
	counter := counter + 1.
	instance mareaUninstallIfNeeded
	].
! !

!AbstractCompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 3/31/2011 10:14'!
on: aMethodReference
	^ super installOn: aMethodReference ! !

!AbstractCompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 12/1/2010 18:07'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!AbstractCompiledMethodProxy methodsFor: 'class membership' stamp: 'MarianoMartinezPeck 12/13/2010 22:37'!
class
	((self mareaClass isRunningTest) or: [self mareaIsProxyInstalled not])
		ifTrue: [^ self mareaClass ]
		ifFalse: [ ^ self mareaUninstall class ].
	! !

!AbstractCompiledMethodProxy methodsFor: 'objects as mehods API' stamp: 'MarianoMartinezPeck 11/30/2010 11:25'!
flushCache
	"Tell the interpreter to remove all references to this method from its method lookup cache, if it has one.  This primitive must be called whenever a method is defined or removed.
	NOTE:  Only one of two selective flush methods needs to be used.
	Squeak 2.2 and earlier uses 119 (See Symbol flushCache).
	Squeak 2.3 and later uses 116 (See CompiledMethod flushCache)."

	<primitive: 116>
! !

!AbstractCompiledMethodProxy methodsFor: 'objects as mehods API' stamp: 'MarianoMartinezPeck 3/31/2011 15:23'!
run: aSelector with: arguments in: aReceiver
	^ self mareaHandler mareaHandleMethodExecutionFor: aSelector with: arguments in: aReceiver proxy: self
	! !

AbstractCompiledMethodProxy subclass: #AbstractCompiledMethodProxySwapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

!AbstractCompiledMethodProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 10:10'!
mareaDefineFileNameFor: aCompiledMethod
	^ self subclassResponsibility ! !

!AbstractCompiledMethodProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 10:11'!
mareaFileName
	^ self subclassResponsibility ! !

!AbstractCompiledMethodProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 10:21'!
mareaHandler
	^ CompiledMethodProxySwapperHandler! !

!AbstractCompiledMethodProxySwapper methodsFor: 'testing' stamp: 'MarianoMartinezPeck 3/31/2011 10:11'!
mareaIsProxyInstalled
	^ self subclassResponsibility ! !

!AbstractCompiledMethodProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/31/2011 10:11'!
mareaMarkAsUninstalled
	! !

!AbstractCompiledMethodProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/31/2011 10:11'!
mareaStoreFileNameIfNecessary: aFileName
	! !

AbstractCompiledMethodProxySwapper subclass: #FilenameCompiledMethodProxySwapper
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

!FilenameCompiledMethodProxySwapper classSide methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 12/13/2010 23:28'!
initialize
	self becomeCompact.! !

!FilenameCompiledMethodProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 15:19'!
mareaDefineFileNameFor: aCompiledMethod
	^ aCompiledMethod mareaPrintString! !

!FilenameCompiledMethodProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/23/2010 12:05'!
mareaFileName
	^ fileName! !

!FilenameCompiledMethodProxySwapper methodsFor: 'testing' stamp: 'MarianoMartinezPeck 11/24/2010 11:33'!
mareaIsProxyInstalled
	^ fileName isNil not! !

!FilenameCompiledMethodProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 11/24/2010 12:10'!
mareaMarkAsUninstalled
	fileName := nil.! !

!FilenameCompiledMethodProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 11/23/2010 12:15'!
mareaStoreFileNameIfNecessary: aFileName
	fileName := aFileName! !

AbstractCompiledMethodProxySwapper subclass: #NumberAsFilenameCompiledMethodProxySwapper
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

!NumberAsFilenameCompiledMethodProxySwapper classSide methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 3/31/2011 10:16'!
initialize
	self becomeCompact.! !

!NumberAsFilenameCompiledMethodProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 10:17'!
mareaDefineFileNameFor: aCompiledMethod
	number := SmallInteger mareaNextNumber.
	^  number asString! !

!NumberAsFilenameCompiledMethodProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 10:17'!
mareaFileName
	^ number asString, '.swap'! !

!NumberAsFilenameCompiledMethodProxySwapper methodsFor: 'testing' stamp: 'MarianoMartinezPeck 3/31/2011 10:17'!
mareaIsProxyInstalled
	^ number isNil not! !

!NumberAsFilenameCompiledMethodProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/31/2011 10:17'!
mareaMarkAsUninstalled
	number := nil.! !

!NumberAsFilenameCompiledMethodProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/31/2011 10:17'!
mareaStoreFileNameIfNecessary: aFileName! !

!AbstractObjectProxy classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 12:34'!
allInstances
	"Answer a collection of all current instances of the receiver."

	| all inst next |
	all := OrderedCollection new.
	inst := self someInstance.
	[inst == nil]
		whileFalse: [
		next := inst mareaNextInstance.
		inst == all ifFalse: [all add: inst].
		inst := next].
	^ all asArray! !

!AbstractObjectProxy classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/31/2011 12:31'!
allInstancesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the current instances of the 
	receiver.
	
	Because aBlock might change the class of inst (for example, using become:),
	it is essential to compute next before aBlock value: inst."
	| inst next |
	inst := self someInstance.
	[inst == nil]
		whileFalse:
		[
		next := inst mareaNextInstance.
		aBlock value: inst.
		inst := next]! !

!AbstractObjectProxy classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/31/2011 10:42'!
installOn: anObject
	| newProxy originalProxy |
	newProxy := self new.
	originalProxy := newProxy mareaInstallFor: anObject.
	ObjectProxyTrap nilMethodDict.
	^ newProxy ! !

!AbstractObjectProxy classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 15:11'!
isRunningTest
	IsRunnintTests isNil ifTrue: [IsRunnintTests := true].
	^ IsRunnintTests ! !

!AbstractObjectProxy classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 15:11'!
runningTest: aBoolean
	IsRunnintTests := aBoolean  ! !

!AbstractObjectProxy methodsFor: 'class membership' stamp: 'MarianoMartinezPeck 3/30/2011 17:13'!
class
	^ self subclassResponsibility ! !

!AbstractObjectProxy methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 3/30/2011 15:11'!
initialize! !

!AbstractObjectProxy methodsFor: 'class membership' stamp: 'MarianoMartinezPeck 3/30/2011 15:37'!
mareaClass
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!AbstractObjectProxy methodsFor: 'handler' stamp: 'MarianoMartinezPeck 3/30/2011 15:43'!
mareaHandler
	^ self subclassResponsibility ! !

!AbstractObjectProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 15:44'!
mareaInstallFor: anObject
	self mareaHandler mareaInstallFor: anObject andProxy: self
	! !

!AbstractObjectProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 3/30/2011 15:11'!
mareaIsProxy
	^ true! !

!AbstractObjectProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 3/30/2011 15:12'!
mareaIsProxyInstalled
	^ self subclassResponsibility ! !

!AbstractObjectProxy methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/30/2011 15:12'!
mareaMarkAsUninstalled
	! !

!AbstractObjectProxy methodsFor: 'enumerating' stamp: 'MarianoMartinezPeck 3/31/2011 12:32'!
mareaNextInstance
	"Primitive. Answer the next instance after the receiver in the 
	enumeration of all instances of this class. Fails if all instances have been 
	enumerated. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 78>
	^nil! !

!AbstractObjectProxy methodsFor: 'message handling' stamp: 'MarianoMartinezPeck 3/31/2011 15:11'!
mareaPerform: selector withArguments: argArray inSuperclass: lookupClass
	"NOTE:  This is just like perform:withArguments:, except that
	the message lookup process begins, not with the receivers's class,
	but with the supplied superclass instead.  It will fail if lookupClass
	cannot be found among the receiver's superclasses.
	Primitive. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 100>
	(selector isSymbol)
		ifFalse: [^ self error: 'selector argument must be a Symbol'].
	(selector numArgs = argArray size)
		ifFalse: [^ self error: 'incorrect number of arguments'].
	(self class == lookupClass or: [self class inheritsFrom: lookupClass])
		ifFalse: [^ self error: 'lookupClass is not in my inheritance chain'].
	self primitiveFailed! !

!AbstractObjectProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 15:45'!
mareaUninstall
	^ self mareaHandler mareaUninstallForProxy: self
! !

!AbstractObjectProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 15:45'!
mareaUninstallIfNeeded
	^ self mareaHandler mareaUninstallIfNeeded: self
! !

AbstractObjectProxy subclass: #AbstractObjectProxySwapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

AbstractObjectProxySwapper class
	instanceVariableNames: 'IsRunnintTests'!

AbstractObjectProxySwapper class
	instanceVariableNames: 'IsRunnintTests'!

!AbstractObjectProxySwapper methodsFor: 'class membership' stamp: 'MarianoMartinezPeck 3/30/2011 17:13'!
class
	((self mareaClass isRunningTest) or: [self mareaIsProxyInstalled not])
		ifTrue: [^ self mareaClass ]
		ifFalse: [ ^ self mareaUninstall class ].
	! !

!AbstractObjectProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 15:36'!
mareaDefineFileNameFor: anObject
	^ self subclassResponsibility! !

!AbstractObjectProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 15:36'!
mareaFileName
	^ self subclassResponsibility ! !

!AbstractObjectProxySwapper methodsFor: 'handler' stamp: 'MarianoMartinezPeck 3/30/2011 15:44'!
mareaHandler
	^ ObjectProxySwapperHandler! !

!AbstractObjectProxySwapper methodsFor: 'testing' stamp: 'MarianoMartinezPeck 3/30/2011 15:36'!
mareaIsProxyInstalled
	^ self subclassResponsibility ! !

!AbstractObjectProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/30/2011 15:46'!
mareaStoreFileNameIfNecessary: aFileName! !

AbstractObjectProxySwapper subclass: #NumberAsFilenameObjectProxySwapper
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

!NumberAsFilenameObjectProxySwapper classSide methodsFor: 'initialize' stamp: 'MarianoMartinezPeck 3/30/2011 12:16'!
initialize
	self becomeCompact! !

!NumberAsFilenameObjectProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 15:19'!
mareaDefineFileNameFor: anObject
	number := SmallInteger mareaNextNumber.
	^  number asString! !

!NumberAsFilenameObjectProxySwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 12:16'!
mareaFileName
	^ number asString, '.swap'! !

!NumberAsFilenameObjectProxySwapper methodsFor: 'testing' stamp: 'MarianoMartinezPeck 3/30/2011 12:16'!
mareaIsProxyInstalled
	^ number isNil not! !

!NumberAsFilenameObjectProxySwapper methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/30/2011 12:16'!
mareaMarkAsUninstalled
	number := nil.! !

AbstractObjectProxy subclass: #ObjectProxyWithTarget
	instanceVariableNames: 'target handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Core'!

ObjectProxyWithTarget class
	instanceVariableNames: 'IsRunnintTests'!

ObjectProxyWithTarget class
	instanceVariableNames: 'IsRunnintTests'!

!ObjectProxyWithTarget classSide methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 3/30/2011 16:34'!
installOn: anObject withHandler: aHandler
	| newProxy originalProxy |
	newProxy := self new.
	newProxy handler: aHandler.
	originalProxy := newProxy mareaInstallFor: anObject.
	ObjectProxyTrap nilMethodDict.
	^ newProxy! !

!ObjectProxyWithTarget methodsFor: 'class membership' stamp: 'MarianoMartinezPeck 3/30/2011 17:13'!
class
	((self mareaClass isRunningTest) or: [self mareaIsProxyInstalled not])
		ifTrue: [^ self mareaClass ]
		ifFalse: [ ^ self target class ].! !

!ObjectProxyWithTarget methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 16:08'!
handler
	^ handler! !

!ObjectProxyWithTarget methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 16:08'!
handler: anObject
	handler := anObject! !

!ObjectProxyWithTarget methodsFor: 'class membership' stamp: 'MarianoMartinezPeck 3/30/2011 16:33'!
mareaHandler
	^ handler! !

!ObjectProxyWithTarget methodsFor: 'testing' stamp: 'MarianoMartinezPeck 3/30/2011 16:05'!
mareaIsProxyInstalled
	^ target isNil not! !

!ObjectProxyWithTarget methodsFor: 'updating' stamp: 'MarianoMartinezPeck 3/30/2011 16:05'!
mareaMarkAsUninstalled
	target := nil! !

!ObjectProxyWithTarget methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 15:50'!
target
	^ target! !

!ObjectProxyWithTarget methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 3/30/2011 15:50'!
target: anObject
	target := anObject! !

!ObjectProxyTrap classSide methodsFor: 'initialize' stamp: 'MarianoMartinezPeck 3/30/2011 15:54'!
initialize
	self nilMethodDict ! !

!ObjectProxyTrap classSide methodsFor: 'method dictionary' stamp: 'MarianoMartinezPeck 3/13/2011 19:24'!
nilMethodDict
	methodDict := nil. ! !

Error subclass: #CannotProxifyCompactClasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Errors'!

Error subclass: #PossibleLoopDetection
	instanceVariableNames: 'arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Errors'!

!PossibleLoopDetection classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 11/25/2010 11:14'!
with: arguments
	^ self new initializeWith: arguments ! !

!PossibleLoopDetection methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/25/2010 11:15'!
arguments 
	^ arguments ! !

!PossibleLoopDetection methodsFor: 'initialize' stamp: 'MarianoMartinezPeck 11/25/2010 11:15'!
initializeWith: aListOfArguments 
	arguments := aListOfArguments! !

Error subclass: #ProxyIsNotInstalled
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Errors'!

Error subclass: #SelectorNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies-Errors'!
SmallInteger initialize!
FilenameCompiledMethodProxySwapper initialize!
NumberAsFilenameCompiledMethodProxySwapper initialize!
NumberAsFilenameObjectProxySwapper initialize!
ObjectProxyTrap initialize!
